SystemOrganization addCategory: #GhostProxies!

!CompiledMethod class methodsFor: '*GhostProxies' stamp: 'MarianoMartinezPeck 2/9/2012 17:20'!
receiver: receiver withArguments: argArray executeMethod: compiledMethod
	"Execute compiledMethod against the receiver and the arguments in argArray"
	"Please do not use this method. It is just there to make sure that we can invoke this primitive with right order of arguments"

	<primitive: 188>
	^receiver withArgs: argArray executeMethod: compiledMethod
! !

!CompiledMethod methodsFor: '*GhostProxies' stamp: 'MarianoMartinezPeck 2/9/2012 11:42'!
ghostPrintString 
	^ self methodClass name asString ,  '>>', self selector! !

!ProtoObject methodsFor: '*GhostProxies' stamp: 'MarianoMartinezPeck 2/9/2012 16:57'!
isProxy 
	^ false! !

!Behavior methodsFor: '*GhostProxies' stamp: 'MarianoMartinezPeck 2/9/2012 16:12'!
ghostFindClassWithNilMethodDictInHierarchy
	methodDict isNil 
		ifTrue: [ ^ self ]
		ifFalse: [ 
			superclass == nil 
				ifTrue: [ ^ nil]
				ifFalse: [ ^ CompiledMethod receiver: superclass withArgs: #() executeMethod: (Behavior >> #ghostFindClassWithNilMethodDictInHierarchy) ]]! !

!Behavior methodsFor: '*GhostProxies' stamp: 'MarianoMartinezPeck 2/9/2012 10:34'!
methodDict
	methodDict == nil ifTrue: ["self manageMDFault" ^ self emptyMethodDictionary  ].
	^ methodDict! !

Object subclass: #GHGhostLogger
	instanceVariableNames: ''
	classVariableNames: 'ProxiesLoggerHolder'
	poolDictionaries: ''
	category: 'GhostProxies'!

!GHGhostLogger class methodsFor: 'change loggers' stamp: 'MarianoMartinezPeck 2/9/2012 11:13'!
changeToFileLogger
	"ProxiesLogger changeToFileLogger"
	^ self initialize! !

!GHGhostLogger class methodsFor: 'change loggers' stamp: 'MarianoMartinezPeck 2/9/2012 11:13'!
changeToTranscriptLogger
	| logger |
	logger := SimpleLogger new.
	logger strategy: TranscriptLoggerStrategy new. 
	logger startLogging.
	ProxiesLoggerHolder := logger.! !

!GHGhostLogger class methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 2/9/2012 11:13'!
createAndSetLogger
	ProxiesLoggerHolder := self createLogger.! !

!GHGhostLogger class methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 2/9/2012 11:13'!
createLogger
	| logger |
	logger := SimpleLogger new.
	logger strategy: (FixesFileNameLoggerStrategy named: 'GhostLog.txt'). 
	logger startLogging.
	^ logger! !

!GHGhostLogger class methodsFor: 'change loggers' stamp: 'MarianoMartinezPeck 2/9/2012 11:13'!
disableLogging
	| logger |
	logger := SimpleLogger new.
	logger strategy: NullLoggerStrategy new. 
	logger startLogging.
	ProxiesLoggerHolder := logger.! !

!GHGhostLogger class methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 2/9/2012 11:13'!
initialize 
	ProxiesLoggerHolder := self createLogger.
	Smalltalk addToShutDownList: self.
	Smalltalk addToStartUpList: self.! !

!GHGhostLogger class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 2/9/2012 11:13'!
logger
	ProxiesLoggerHolder
		ifNil: [ProxiesLoggerHolder := self createLogger].
	^ ProxiesLoggerHolder! !

!GHGhostLogger class methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 2/9/2012 11:13'!
reopenStreamIfExists
	self logger reopenStreamIfClosed! !

!GHGhostLogger class methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 2/9/2012 11:13'!
shutDown
! !

!GHGhostLogger class methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 2/9/2012 11:13'!
startUp
	self reopenStreamIfExists! !

!GHGhostLogger methodsFor: 'seeClassSide' stamp: 'MarianoMartinezPeck 2/9/2012 11:13'!
seeClassSide ! !

Object subclass: #GHInstanceOfProxifiedClassInterceptionDelegator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!GHInstanceOfProxifiedClassInterceptionDelegator methodsFor: 'intercepting' stamp: 'MarianoMartinezPeck 2/9/2012 17:21'!
cannotInterpret: aMessage 
	| interception context  counter proxy |
	
	"In this case, 'self' is the instance whose class was proxified. Therefore, we cannot send ANY message to 'self' because we will cause an infinitive loop '"
	GHGhostLogger logger log:   'cannotInterpret:  ', aMessage selector.
	GHGhostLogger logger log:   'Stack:  '.
	GHGhostLogger logger log:   '----------------'.
		
	context := thisContext sender.
	counter := 0.
	[context isNil not and: [counter < 50]] whileTrue:  [
		GHGhostLogger logger log:  context  method ghostPrintString.
		context := context sender.
		counter := counter + 1.
		].
	
	"We first have to find the proxy, that is, we need to search in the hierarchy the first class (or proxy) whose methodDict is nil. Usually here I should be able todo 'aMessage lookupClass mareaFindClassWithNilMethodDictInHierarchy', but in this particular case, that would lead into a system crash when swapping out classes. As an example, I have have the class XXX and its subclass YYY. We swapped XXX and now YYY has received a message. The VM see that XXX has its methodDict in nil and sends #cannotInterpret:.  If here we do 'aMessage lookupClass mareaFindClassWithNilMethodDictInHierarchy' to YYY, it will loop, because it will find again that it superclass (XXX) has the methodDict in nil. So we CANNOT send any message here because it will be trap again. We need to avoid the method lookup. For that purpose, we directly evaluate the compiled method #mareaFindClassWithNilMethodDictInHierarchy in each class of the hierarchy until we find the proxy. It is not risky to use this compiledMethod because the instance variables 'methodDict' and 'superclass' won't change they place, hence the bytecode will always be correct for classes. 
	This problem is exactly the same we have in #updateMissingSharedProxiesFrom: materializedInstances filling: dict."
	proxy := CompiledMethod receiver: aMessage lookupClass withArguments: #() executeMethod: (Behavior >> #ghostFindClassWithNilMethodDictInHierarchy).
	^ proxy handleInterceptionToInstance: aMessage andReceiver: self
	
! !

Object subclass: #GHInterception
	instanceVariableNames: 'message proxy receiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!GHInterception class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 2/9/2012 10:31'!
for: aMessage proxy: aProxy
	^ self new initializeWith: aMessage proxy: aProxy receiver: nil. ! !

!GHInterception methodsFor: 'initialization' stamp: 'MarianoMartinezPeck 2/9/2012 10:32'!
initializeWith: aMessage proxy: aProxy receiver: aReceiver
	message := aMessage.
	proxy := aProxy.
	receiver := aReceiver.! !

!GHInterception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 2/9/2012 10:55'!
message
	^ message! !

!GHInterception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 2/9/2012 10:55'!
proxy
	^ proxy! !

!GHInterception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 2/9/2012 10:55'!
receiver
	^ receiver! !

Object subclass: #GHInterceptionDelegator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!GHInterceptionDelegator methodsFor: 'intercepting' stamp: 'MarianoMartinezPeck 2/9/2012 16:22'!
cannotInterpret: aMessage 
	| interception context  counter|
	
	self log:  'cannotInterpret:  ', aMessage selector.
	self log:  'Stack:  '.
	self log:  '----------------'.
		
	context := thisContext sender.
	counter := 0.
	[context isNil not and: [counter < 50]] whileTrue:  [
		self log: context  method ghostPrintString.
		context := context sender.
		counter := counter + 1.
		].
		
	interception := GHInterception for: aMessage proxy: self. 
	^ self proxyHandler handleInterception: interception.! !

GHInterceptionDelegator subclass: #GHProxyTrap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

GHProxyTrap subclass: #GHAbstractProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

GHAbstractProxy subclass: #GHAbstractClassProxy
	instanceVariableNames: 'superclass methodDict format'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!GHAbstractClassProxy methodsFor: 'initialization' stamp: 'MarianoMartinezPeck 2/9/2012 15:36'!
initializeClassProxy
	superclass := GHInstanceOfProxifiedClassInterceptionDelegator.
	methodDict := nil.
	format := GHAbstractClassProxy format.! !

GHAbstractClassProxy subclass: #GHClassProxy
	instanceVariableNames: 'handler target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!GHClassProxy class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 2/9/2012 14:23'!
createProxyAndReplace: anObjectThenProxy handler: aHandler
   | aProxyThenObject |
	"It is important to use basicNew because otherwise we are forced to implement #initialize"
       aProxyThenObject := self basicNew
		initializeWith: anObjectThenProxy
		handler: aHandler. 
		"I cannot send #become because it will be intercepted by the proxy"	
	(Array with: aProxyThenObject)
		elementsExchangeIdentityWith:
			(Array with: anObjectThenProxy).
        "After the become is done, aProxyThenObject now points
	 to the original object, and  anObjectThenProxy points to 
	the proxy"
       anObjectThenProxy proxyTarget: aProxyThenObject.
	GHProxyTrap initialize.
       ^ anObjectThenProxy.
! !

!GHClassProxy class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 2/9/2012 14:22'!
createProxyFor: anObject handler: aHandler
	| aProxy |
	"It is important to use basicNew because otherwise we are forced to implement #initialize"
    	aProxy:= self basicNew
		initializeWith: anObject
		handler: aHandler. 
       GHProxyTrap initialize.
       ^ aProxy.
! !

!GHClassProxy methodsFor: 'initialization' stamp: 'MarianoMartinezPeck 2/9/2012 14:24'!
initializeWith: aTarget handler: aHandler
	self initializeClassProxy.
	target := aTarget.
	handler := aHandler.
	! !

!GHClassProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 2/9/2012 14:25'!
proxyHandler
	^ handler! !

!GHClassProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 2/9/2012 14:25'!
proxyTarget
	^ target! !

!GHClassProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 2/9/2012 14:25'!
proxyTarget: anObject
	target := anObject! !

!GHAbstractProxy methodsFor: 'class membership' stamp: 'MarianoMartinezPeck 2/9/2012 11:44'!
class
	"We just need it for debugging purposes"
	
	<primitive: 111>
	self primitiveFailed! !

!GHAbstractProxy methodsFor: 'logging' stamp: 'MarianoMartinezPeck 2/9/2012 11:39'!
log: aString
	GHGhostLogger logger log: aString.! !

!GHAbstractProxy methodsFor: 'API' stamp: 'MarianoMartinezPeck 2/9/2012 16:29'!
proxyHandler
	"This must be implemented in subclasses"! !

GHAbstractProxy subclass: #GHProxy
	instanceVariableNames: 'handler target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!GHProxy class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 2/9/2012 11:54'!
createProxyAndReplace: anObjectThenProxy handler: aHandler
   | aProxyThenObject |
	"It is important to use basicNew because otherwise we are forced to implement #initialize"
       aProxyThenObject := self basicNew
		initializeWith: anObjectThenProxy
		handler: aHandler. 
		"I cannot send #become because it will be intercepted by the proxy"	
	(Array with: aProxyThenObject)
		elementsExchangeIdentityWith:
			(Array with: anObjectThenProxy).
        "After the become is done, aProxyThenObject now points
	 to the original object, and  anObjectThenProxy points to 
	the proxy"
       anObjectThenProxy proxyTarget: aProxyThenObject.
	GHProxyTrap initialize.
       ^ anObjectThenProxy.
! !

!GHProxy class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 2/9/2012 11:51'!
createProxyFor: anObject handler: aHandler
	| aProxy |
	"It is important to use basicNew because otherwise we are forced to implement #initialize"
    	aProxy:= self basicNew
		initializeWith: anObject
		handler: aHandler. 
       GHProxyTrap initialize.
       ^ aProxy.
! !

!GHProxy methodsFor: 'initialization' stamp: 'MarianoMartinezPeck 2/9/2012 10:42'!
initializeWith: aTarget handler: aHandler
	target := aTarget.
	handler := aHandler! !

!GHProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 2/9/2012 16:57'!
isProxy
	^ true! !

!GHProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 2/9/2012 11:23'!
proxyHandler
	^ handler! !

!GHProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 2/9/2012 10:57'!
proxyTarget
	^ target! !

!GHProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 2/9/2012 10:43'!
proxyTarget: aTarget
	target := aTarget! !

!GHProxyTrap class methodsFor: 'class initialization' stamp: 'MarianoMartinezPeck 2/9/2012 10:35'!
initialize
	self nilMethodDict ! !

!GHProxyTrap class methodsFor: 'class initialization' stamp: 'MarianoMartinezPeck 2/9/2012 10:35'!
nilMethodDict
	methodDict := nil. ! !

Object subclass: #GHProxyHandler
	instanceVariableNames: 'methodsNotToIntercept'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!GHProxyHandler methodsFor: 'handle - class proxy' stamp: 'MarianoMartinezPeck 2/9/2012 14:41'!
classProxyMessagesToHandle
	| dict |
	dict := Dictionary new.
	dict at: #handleInterceptionToInstance:andReceiver:  put: #handleInterceptionToInstanceFor:.
	^ dict
! !

!GHProxyHandler methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 2/9/2012 16:51'!
debuggingMessagesToHandle
	| dict |
	dict := Dictionary new.
	dict at: #basicInspect put:#handleBasicInspect:.
	dict at: #inspect put:#handleInspect:.
	dict at: #inspectorClass put:#handleInspectorClass:.
	dict at: #defaultLabelForInspector put:#handleDefaultLabelForInspector:.
	dict at: #printStringLimitedTo: put: #handlePrintStringLimitedTo:.
	dict at: #printString put: #handlePrintString:.
	dict at: #longPrintOn:limitedTo:indent: put: #handleLongPrintOnLimitedToIndent:.
	^ dict	! !

!GHProxyHandler methodsFor: 'private' stamp: 'MarianoMartinezPeck 2/9/2012 16:23'!
defaultMethodsNotToIntercept
	| dict |
	dict := Dictionary new.
	dict addAll: self methodsMessagesToHandle.
	dict addAll: self debuggingMessagesToHandle.
	dict addAll: self testSupportMessagesToHandle.
	dict addAll: self classProxyMessagesToHandle.
	^ dict
	
	! !

!GHProxyHandler methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 2/9/2012 16:51'!
handleBasicInspect: anInterception
	"Create and schedule an Inspector in which the user can examine the 
	receiver's variables. This method should not be overriden."
	^Smalltalk tools basicInspect: anInterception proxy! !

!GHProxyHandler methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 2/9/2012 16:52'!
handleDefaultLabelForInspector: anInterception
	^ 'Proxy'! !

!GHProxyHandler methodsFor: 'handle - methods' stamp: 'MarianoMartinezPeck 2/9/2012 16:26'!
handleFlushCache: anInterception
	^ self subclassResponsibility ! !

!GHProxyHandler methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 2/9/2012 16:52'!
handleInspect: anInterception
	"Create and schedule an Inspector in which the user can examine the receiver's variables."
	Smalltalk tools inspect: anInterception proxy! !

!GHProxyHandler methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 2/9/2012 16:52'!
handleInspectorClass: anInterception
	"Answer the class of the inspector to be used on the receiver.  Called by inspect; 
	use basicInspect to get a normal (less useful) type of inspector."

	^ Inspector! !

!GHProxyHandler methodsFor: 'handle - API' stamp: 'MarianoMartinezPeck 2/9/2012 12:10'!
handleInterception: anInterception
	self log:  'message ', anInterception message selector, ' intercepted'.
	
	(self isMessageNotToIntercept: anInterception message)
		ifTrue: [ ^ self manageMessageInternally: anInterception  ]
	 	ifFalse: [ ^ self manageMessage: anInterception  ]
	! !

!GHProxyHandler methodsFor: 'handle - class proxy' stamp: 'MarianoMartinezPeck 2/9/2012 16:28'!
handleInterceptionToInstanceFor: anInterception
	^ self subclassResponsibility ! !

!GHProxyHandler methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 2/9/2012 16:52'!
handleLongPrintOnLimitedToIndent: anInterception
	! !

!GHProxyHandler methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 2/9/2012 16:52'!
handleLongPrintStringLimitedTo: anInterception
	^ 'This is a proxy'! !

!GHProxyHandler methodsFor: 'handle - methods' stamp: 'MarianoMartinezPeck 2/9/2012 16:26'!
handleMethodExecution: anInterception
	^ self subclassResponsibility ! !

!GHProxyHandler methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 2/9/2012 16:52'!
handlePrintOn: anInterception
	anInterception message arguments first nextPutAll: 'aProxy'  ! !

!GHProxyHandler methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 2/9/2012 16:52'!
handlePrintString: anInterception
	^ anInterception proxy printStringLimitedTo: 50000! !

!GHProxyHandler methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 2/9/2012 16:52'!
handlePrintStringLimitedTo: anInterception
	^ 'This is the print of a proxy'! !

!GHProxyHandler methodsFor: 'handle - support' stamp: 'MarianoMartinezPeck 2/9/2012 16:27'!
handleUninstall: anInterception
	^ self subclassResponsibility ! !

!GHProxyHandler methodsFor: 'private' stamp: 'MarianoMartinezPeck 2/9/2012 12:10'!
isMessageNotToIntercept: aMessage
	^ self methodsNotToIntercept includesKey: aMessage selector  ! !

!GHProxyHandler methodsFor: 'private' stamp: 'MarianoMartinezPeck 2/9/2012 16:23'!
log: aString
	GHGhostLogger logger log: aString.! !

!GHProxyHandler methodsFor: 'handle - API' stamp: 'MarianoMartinezPeck 2/9/2012 16:28'!
manageMessage: interception
	^ self subclassResponsibility ! !

!GHProxyHandler methodsFor: 'private' stamp: 'MarianoMartinezPeck 2/9/2012 12:10'!
manageMessageInternally: anInterception 
	self log: 'The method ', anInterception message selector, ' will NOT be forwarded by instead answer by the handler'.
	^ self perform: (self methodsNotToIntercept at: anInterception message selector) with: anInterception ! !

!GHProxyHandler methodsFor: 'handle - methods' stamp: 'MarianoMartinezPeck 2/9/2012 11:46'!
methodsMessagesToHandle
	| dict |
	dict := Dictionary new.
	dict at: #flushCache put: #handleFlushCache:.
	dict at: #run:with:in: put: #handleMethodExecution:.
	^ dict
! !

!GHProxyHandler methodsFor: 'private' stamp: 'MarianoMartinezPeck 2/9/2012 11:45'!
methodsNotToIntercept
	methodsNotToIntercept isNil ifTrue: [ methodsNotToIntercept := self defaultMethodsNotToIntercept ].
	^ methodsNotToIntercept ! !

!GHProxyHandler methodsFor: 'handle - support' stamp: 'MarianoMartinezPeck 2/9/2012 14:58'!
testSupportMessagesToHandle
	| dict |
	dict := Dictionary new.
	dict at: #uninstall put: #handleUninstall:.
	^ dict 
	! !

GHProxyHandler subclass: #GHSimpleForwarderProxyHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxies'!

!GHSimpleForwarderProxyHandler methodsFor: 'handle - methods' stamp: 'MarianoMartinezPeck 2/9/2012 11:47'!
handleFlushCache: anInterception
	^ anInterception proxy proxyTarget selector flushCache	 
		! !

!GHSimpleForwarderProxyHandler methodsFor: 'handle - class proxy' stamp: 'MarianoMartinezPeck 2/9/2012 17:21'!
handleInterceptionToInstanceFor: anInterception
	| message targetClass receiver |
	message := anInterception message arguments first.
	targetClass := anInterception proxy proxyTarget.
	receiver := anInterception message arguments second.
	self log: 'message ', message selector, ' to instance intercepted and will be forwarded'.
	^ CompiledMethod receiver: receiver withArguments: message arguments  executeMethod:  (targetClass lookupSelector: message selector) 
	! !

!GHSimpleForwarderProxyHandler methodsFor: 'handle - methods' stamp: 'MarianoMartinezPeck 2/9/2012 11:47'!
handleMethodExecution: anInterception
	self log: 'message ', anInterception message selector, ' execution intercepted and will be forwarded'.
	^ anInterception proxy proxyTarget valueWithReceiver: anInterception message arguments third arguments: anInterception message arguments second
	
! !

!GHSimpleForwarderProxyHandler methodsFor: 'handle - support' stamp: 'MarianoMartinezPeck 2/9/2012 14:59'!
handleUninstall: anInterception

	self log: 'message ', anInterception message selector, ' received and the proxy will be uninstalled'.
	^ anInterception proxy proxyTarget become: anInterception proxy.
	! !

!GHSimpleForwarderProxyHandler methodsFor: 'handle' stamp: 'MarianoMartinezPeck 2/9/2012 10:57'!
manageMessage: interception
	self log: 'The method ', interception message selector, ' will beforwarded'.
	^ interception message sendTo: interception proxy proxyTarget! !
GHGhostLogger initialize!
GHProxyTrap initialize!
